#include <stdint.h>
#include <stdlib.h>

// this function is based on https://stackoverflow.com/questions/9465815/rgb-to-yuv420-algorithm-efficiency
void Bitmap2Yuv420p_calc2(uint8_t *const destination, const uint8_t *const rgb, const size_t width, const size_t height)
{
	const size_t image_size = width * height, w2 = width / 2;
	const uint8_t *p = rgb;
	uint8_t *Y = destination;
	uint8_t *U = Y + image_size;
	uint8_t *V = Y + image_size + image_size / 4;

	for(size_t line = 0; line < height; ++line) {
		if (line & 1) {
			for(size_t x = 0; x < width; x++) {
				uint8_t r = *p++;
				uint8_t g = *p++;
				uint8_t b = *p++;

				*Y++ = ((66*r + 129*g + 25*b) >> 8) + 16;
			}
		}
		else {
			for(size_t x = 0; x < w2; x++) {
				uint8_t r = *p++;
				uint8_t g = *p++;
				uint8_t b = *p++;

				*Y++ = ((66*r + 129*g + 25*b) >> 8) + 16;
				*U++ = ((-38*r + -74*g + 112*b) >> 8) + 128;
				*V++ = ((112*r + -94*g + -18*b) >> 8) + 128;

				r = *p++;
				g = *p++;
				b = *p++;

				*Y++ = ((66*r + 129*g + 25*b) >> 8) + 16;
			}
		}
	}
}
